/******************************************************************************/
/******************************************************************************/
/***                                                                        ***/
/***                       ADConv.h : LED Desk Light                        ***/
/***                                                                        ***/
/*** 쐬 : 2024.05.^                                    by : S.Suzuki   ***/
/******************************************************************************/
/******************************************************************************/
/*  : ATtiny85płB                                                    */

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	"main.h"
#include	"ADConv.h"

/* Ɨp ***************************************************************/

static	BYTE	s_byADChNum;	/* ϊA/D`Flԍ         */
static	BYTE	s_byADMesCnt1;	/* `lPA/Dϊ */
static	BYTE	s_byADMesCnt2;	/* `lQA/Dϊ */
static	WORD	s_wADAccMes1;	/* `lPA/DϊώZf[^ */
static	WORD	s_wADAccMes2;	/* `lQA/DϊώZf[^ */
BYTE	s_byADdata1;			/* `lPA/Dϊf[^i0`255j */
BYTE	s_byADdata2;			/* `lQA/Dϊf[^i0`255j */

/* A/DRo[^̏ ******************************************************/
/*  : A/DϊNbN50`200KHzKvB                                 */

void Init_ADC(void)
{
	/* }`vNTEZN^WX^ */
	ADMUX = 0x00;				/* b7-b6:RES[1-0] = 00 : VCCdƂ    */
								/*    b5:ADLAR = 0 : A/Df[^l߂ɂȂ  */
								/*    b4:RES2  = 0 :                            */
								/* b3-b0:MUX[3-0] = 0000 : `lADC0I */
	/* EXe[^XWX^` */
#if PCLK == CLK01			/* PCLK=1MHẑƂ */
	ADCSRA = 0x9C;				/*    b7:ADEN  = 1 : A/DivXPJnj  */
								/*    b6:ADSC  = 0 : A/DϊJn            */
								/*    b5:ADATE = 0 : A/DgK֎~          */
								/*    b4:ADIF  = 1 : A/Dϊ荞ݗvtONA */
								/*    b3:ADIE  = 1 : A/Dϊ荞݋    */
								/* b2-b0:ADPS[2-0] = 100 : A/DϊۯPCLK/16 */
								/*                   PCLK=1MHẑƂ 62.5KHz  */
#elif PCLK == CLK08			/* PCLK=8MHẑƂ */
	ADCSRA = 0x9F;				/*    b7:ADEN  = 1 : A/DivXPJnj   */
								/*    b6:ADSC  = 0 : A/DϊJn             */
								/*    b5:ADATE = 0 : A/DgK           */
								/*    b4:ADIF  = 1 : A/Dϊ荞ݗvtONA */
								/*    b3:ADIE  = 1 : A/Dϊ荞݋     */
								/* b2-b0:ADPS[2-0] = 111 : A/DϊۯPCLK/128 */
								/*                  PCLK=8MHẑƂ 62.5KHz    */
#elif
	#error Peripheral Clock Setting Error.
#endif
	/* EXe[^XWX^a */
	ADCSRB = 0x00;				/*    b7:BIN  = 0 : ɓ͓֎~                        */
								/*    b6:ACME = 0 : AiORp[^}`vNT֎~  */
								/*    b5:IPR  = 0 : ͋ɐ]                        */
								/* b4-b3:irbgȂj                                     */
								/* b2-b0:ADTS2`ADTS0 = 000 : A/DgKȂiAj */
	/* DIfBZ[uWX^ */
	DIDR0 = 0x14;				/* b7-b6:irbgȂj                       */
								/*    b5:ADC0D = 0 : ADC0̃fW^͗L   */
								/*    b4:ADC2D = 1 : ADC2̃fW^͖   */
								/*    b3:ADC3D = 0 : ADC3̃fW^͗L   */
								/*    b2:ADC1D = 1 : ADC1̃fW^͖   */
								/* b1-b0:AIN[1-0]D = 00 : AIN1`AIN0̃fW^͗L  */

	s_byADChNum = 1;			/* ŏɕϊ`lԍZbg */
}

/* A/Dϊ荞ݏ ****************************************************/
/*  : (1)ADCSRA.ADSC͕ϊ'0'ɖ߂B                         */
/*      : (2)ADCSRA.ADIF͊荞݂'0'ɖ߂B                     */
/*      : (3)A/Dϊf[^̓WX^ADCHǂݍނ܂ōXVȂB10rbg  */
/*      :    f[^gpƂ͉ʂ̃WX^ADCLǂݍނƁB       */

ISR(ADC_vect)
{
	WORD	wWork;

	/* A/Dϊf[^ǂݍ݁i10rbgf[^ADCHb1`b0CADCLb7`b0ɂj */
	wWork  = (WORD)ADCL;		/* A/DʃoCgǂݍ */
	wWork |= (WORD)(ADCH << 8);	/* A/DʃoCgǂݍ */
	/* `lƂ̕ωiS̕ρj */
	switch(ADMUX & 0x0F){
		case 1:		/* `lP */
			s_wADAccMes1 += wWork;
			s_byADMesCnt1++;
			if(4 <= s_byADMesCnt1){		/* SώZ */
				s_byADdata1 = (BYTE)(s_wADAccMes1 >> 4);	/* 1/4b1`b0j */
				s_wADAccMes1  = 0;
				s_byADMesCnt1 = 0;
			}
			break;
		case 2:		/* `lQ */
			s_wADAccMes2 += wWork;
			s_byADMesCnt2++;
			if(4 <= s_byADMesCnt2){		/* SώZ */
				s_byADdata2 = (BYTE)(s_wADAccMes2 >> 4);	/* 1/4b1`b0j */
				s_wADAccMes2  = 0;
				s_byADMesCnt2 = 0;
			}
			break;
		default:
			break;
	}
}

/*  A/DϊJn ***************************************************************/
/*  : ϊԂ́AʏA/DϊJn 13NbNA܂      */
/*        ADCSRA.ADEN='1'Ƃ 25NbNB                            */

void Start_AD(void)
{
	ADMUX = (ADMUX & 0xF0) | (s_byADChNum & 0x0F);
	ADCSRA = (ADCSRA | 0x40);			/* b6:ADSC = 1 : A/DϊJn */
	/* `lXV */
	s_byADChNum++;
	if(2 < s_byADChNum){
		s_byADChNum = 1;
	}
}


/* End of File */
